-- =================================================================================
-- = AutoSellTrash
-- = Author: Bumerang
-- =================================================================================

AutoSellTrash =
	{
	["Events"]		= {"LOADING_END", "VARIABLES_LOADED", "UNIT_PORTRAIT_UPDATE"},
	["Addonname"]		= "Auto Sell Trash",
	["Version"]		= "0.07",
	["Language"]		= "EN"
	};
	
function AutoSellTrash_LoadFile(filename)
	local func, err = loadfile(filename)
	if err then	return false, err end
	dofile(filename)
	return true
end

local prevBagState = nil;
local player = "Famke"; -- hello Alisa!!!

AutoSellTrash.Strings = {}
AutoSellTrash.Strings.AddonName = "AutoSellTrash"
AutoSellTrash.Strings.AddonDesc = "Sells trash items automatically."
AutoSellTrash.Strings.IconPath = "Interface/Addons/AutoSellTrash/gfx/AutoSellTrash-64x64.png"
AutoSellTrash.Strings.Author = "Bumerang"
AutoSellTrash.Strings.Version = "0.07"

AutoSellTrash.Defaults =
	{
	["SavedVersion"]		= AutoSellTrash.Strings.Version,
	["Exclude"]			= "",
	["Include"]			= "",
	["Rules"]			= "",
	["Rarity"] =
		{
		["WHITE"]		= true,
		["GREEN"]		= true,
		["BLUE"]		= false,
		["PURPLE"]		= false,
		["EPIC"]		= false
		},
	["MaxQuality"]			= 101,
	["MaxStatLevel"]		= 7,
	["MaxStatLevel2"]		= 4,
	["MaxStatCnt"]			= 1,
	["MaxLevel"]			= 53,
	["ChatMsg"]			= true,
	["ConfigPosX"]			= 150,
	["ConfigPosY"]			= 150
	};


function AutoSellTrash_OnLoad(this)   

	if (AutoSellTrash_Settings == nil)then
		AutoSellTrash_Settings = {};
	end

	AutoSellTrash.Language = GetLocation()

	if not AutoSellTrash_LoadFile("Interface/Addons/AutoSellTrash/Locales/"..AutoSellTrash.Language..".lua") then
		DEFAULT_CHAT_FRAME:AddMessage(string.format("Cannot load file: Interface/Addons/AutoSellTrash/Locales/%s.lua", AutoSellTrash.Language))
		AutoSellTrash_LoadFile("Interface/Addons/AutoSellTrash/Locales/EN.lua")
	end	

	AutoSellTrash.QualityColors =
		{
		"ffffff",
		"00ff00",
		"0072bc",
		"c805f8",
		"f68e56",
		"a37d50",
		};

	AutoSellTrash.ListEntries =
		{
		"|cff"..AutoSellTrash.QualityColors[1]..AutoSellTrash.Language.GUI_White.."|r",
		"|cff"..AutoSellTrash.QualityColors[2]..ITEM_QUALITY1_DESC.."|r",
		"|cff"..AutoSellTrash.QualityColors[3]..ITEM_QUALITY2_DESC.."|r",
		"|cff"..AutoSellTrash.QualityColors[4]..ITEM_QUALITY3_DESC.."|r",
		"|cff"..AutoSellTrash.QualityColors[5]..ITEM_QUALITY4_DESC.."|r",
		"|cff"..AutoSellTrash.QualityColors[6]..ITEM_QUALITY5_DESC.."|r"
		};


	for _,regevent in pairs(AutoSellTrash.Events) do
		this:RegisterEvent(regevent);
	end;
	
	SaveVariables("AutoSellTrash_Settings");
end

function AutoSellTrash.LoadSavedSettings()

	if (AutoSellTrash_Settings[player] == nil) then
		AutoSellTrash_Settings[player] = AutoSellTrash.Defaults;
	end;
		
	AutoSellTrash.SetConfigFrame();
	AutoSellTrash_Config:SetPos(AutoSellTrash_Settings[player].ConfigPosX, AutoSellTrash_Settings[player].ConfigPosY);
end;

function AutoSellTrash.StartOrStop(mode)
	if (mode == nil)	then 
    	AutoSellTrash_Settings[player].Active = not AutoSellTrash_Settings[player].Active;
	elseif (mode == "off")	then 
    	AutoSellTrash_Settings[player].Active = false;
	elseif (mode == "on")	then 
    	AutoSellTrash_Settings[player].Active = true;
	end;

	if (AutoSellTrash_Settings[player].Active==true) then
		AutoSellTrash_Config_StartOrStop:SetText(AutoSellTrash.Language.GUI_on);
	else                                     
		AutoSellTrash_Config_StartOrStop:SetText(AutoSellTrash.Language.GUI_off);
	end;

	if (AutoSellTrash_Settings[player].Active == true ) then
		DEFAULT_CHAT_FRAME:AddMessage("AutoSellTrash: |cff40ff40"..AutoSellTrash.Language.GUI_on.."|r!");
	else
		DEFAULT_CHAT_FRAME:AddMessage("AutoSellTrash: |cffff4040"..AutoSellTrash.Language.GUI_off.."|r!");
	end;	
end;

function AutoSellTrash.SaveConfig()
	AutoSellTrash_Settings[player].Rarity.WHITE		= AutoSellTrash_Config_White:IsChecked();
	AutoSellTrash_Settings[player].Rarity.GREEN 		= AutoSellTrash_Config_Green:IsChecked();
	AutoSellTrash_Settings[player].Rarity.BLUE 		= AutoSellTrash_Config_Blue:IsChecked();
	AutoSellTrash_Settings[player].Rarity.PURPLE 		= AutoSellTrash_Config_Purple:IsChecked();
	AutoSellTrash_Settings[player].Rarity.EPIC 		= AutoSellTrash_Config_Epic:IsChecked();

	AutoSellTrash_Settings[player].Exclude 			= AutoSellTrash_Config_Exclude:GetText();
	AutoSellTrash_Settings[player].Include 			= AutoSellTrash_Config_Include:GetText();
	AutoSellTrash_Settings[player].Rules 			= AutoSellTrash_Config_Rules:GetText();
	AutoSellTrash_Settings[player].ChatMsg 			= AutoSellTrash_Config_ChatMsg:IsChecked();

   	local num = tonumber(AutoSellTrash_Config_MaxQuality:GetText());
   	if(not num)then
   		AutoSellTrash_Settings[player].MaxQuality = 101;
   	else
   		AutoSellTrash_Settings[player].MaxQuality = num;
   	end

   	num = tonumber(AutoSellTrash_Config_MaxStatLevel:GetText());
   	if(not num)then
   		AutoSellTrash_Settings[player].MaxStatLevel = 7;
   	else
   		AutoSellTrash_Settings[player].MaxStatLevel = num;
   	end

   	num = tonumber(AutoSellTrash_Config_MaxStatLevel2:GetText());
   	if(not num)then
   		AutoSellTrash_Settings[player].MaxStatLevel2 = 4;
   	else
   		AutoSellTrash_Settings[player].MaxStatLevel2 = num;
   	end

   	num = tonumber(AutoSellTrash_Config_MaxStatCnt:GetText());
   	if(not num)then
   		AutoSellTrash_Settings[player].MaxStatCnt = 1;
   	else
   		AutoSellTrash_Settings[player].MaxStatCnt = num;
   	end

   	num = tonumber(AutoSellTrash_Config_MaxLevel:GetText());
   	if(not num)then
   		AutoSellTrash_Settings[player].MaxLevel = 53;
   	else
   		AutoSellTrash_Settings[player].MaxLevel = num;
   	end
	
 	DEFAULT_CHAT_FRAME:AddMessage(AutoSellTrash.Language.MsgSaved, 1.0, 1.0, 0.0);	
end;

function AutoSellTrash.SetConfigFrame()

	AutoSellTrash_Config_White:SetChecked(AutoSellTrash_Settings[player].Rarity.WHITE);
	AutoSellTrash_Config_Green:SetChecked(AutoSellTrash_Settings[player].Rarity.GREEN);
	AutoSellTrash_Config_Blue:SetChecked(AutoSellTrash_Settings[player].Rarity.BLUE);
	AutoSellTrash_Config_Purple:SetChecked(AutoSellTrash_Settings[player].Rarity.PURPLE);
	AutoSellTrash_Config_Epic:SetChecked(AutoSellTrash_Settings[player].Rarity.EPIC);

   	AutoSellTrash_Config_Exclude:SetText(AutoSellTrash_Settings[player].Exclude);
   	AutoSellTrash_Config_Include:SetText(AutoSellTrash_Settings[player].Include);
   	AutoSellTrash_Config_Rules:SetText(AutoSellTrash_Settings[player].Rules);
   	AutoSellTrash_Config_ChatMsg:SetChecked(AutoSellTrash_Settings[player].ChatMsg);

	AutoSellTrash_Config_MaxQuality:SetText(AutoSellTrash_Settings[player].MaxQuality);
	AutoSellTrash_Config_MaxStatLevel:SetText(AutoSellTrash_Settings[player].MaxStatLevel);
	AutoSellTrash_Config_MaxStatLevel2:SetText(AutoSellTrash_Settings[player].MaxStatLevel2);
	AutoSellTrash_Config_MaxStatCnt:SetText(AutoSellTrash_Settings[player].MaxStatCnt);
	AutoSellTrash_Config_MaxLevel:SetText(AutoSellTrash_Settings[player].MaxLevel);
end;

function AutoSellTrash.Toggle(box,msg)
	if (AutoSellTrash_Config:IsVisible()) then AutoSellTrash_Config:Hide();
	else AutoSellTrash.SetConfigFrame(); AutoSellTrash_Config:Show();
	end;
end;

function AutoSellTrashConfig_Toogle()
  AutoSellTrash.Toggle();
end


function AutoSellTrashConfig_ClearAllText(tooltip)
    tooltip:ClearLines()
    for i = 1, 40 do
        local left = _G[tooltip:GetName() .. "TextLeft" .. i]
        local right = _G[tooltip:GetName() .. "TextRight" .. i]
        left:SetText("")
        right:SetText("")
    end
end

function AutoSellTrashConfig_ReadTooltipText(tooltip)
    local data = ""
    for i = 1, 20 do
        local left = _G[tooltip:GetName() .. "TextLeft" .. i]
        local right = _G[tooltip:GetName() .. "TextRight" .. i]
        
        local hasText = false
        if left:GetText() and left:GetText() ~= ""  then 
            hasText = true
	    	data = data .. left:GetText().."\n"; 
        end
        if right:GetText() and right:GetText() ~= ""  then 
            hasText = true
	    	data = data .. right:GetText().."\n"; 
        end
        if not hasText then
            break
        end
    end
    return data
end

function AutoSellTrashConfig_GetBagItemDesc(_bagSlot)
    local index = GetBagItemInfo(_bagSlot);
    AutoSellTrashConfig_ClearAllText(AutoSellTrashTooltip)
    AutoSellTrashTooltip:SetBagItem(index);
    AutoSellTrashTooltip:Hide();

    local txt = AutoSellTrashConfig_ReadTooltipText(AutoSellTrashTooltip);
    
    local data = Sol.tooltip.ReadTooltip(AutoSellTrashTooltip);
    
    --DEFAULT_CHAT_FRAME:AddMessage("Tooltip: "..txt);
    return txt, data;
end


function AutoSellTrashConfig_GetLineColor(lines, index)
    local name = lines.left[index].text;
    local line_color = lines.left[index].color;
    local color = "FFFFFF";
    if(line_color)then
		color = Sol.color.ColorValuesToHexColor(line_color[1], line_color[2], line_color[3])
	else
    	if (name:sub(1,2) == "|c") then 
			color = name:sub(5, 10)
		end
	end
	return color;
end	

function AutoSellTrashConfig_GetBagItemAttr(_bagSlot)
    local txt, lines = AutoSellTrashConfig_GetBagItemDesc(_bagSlot);
    
    local index = 1
	local level = -1

    if not lines.left[index] then
        return 0,0,0,0,-1,-1,{}
    end
    
    if lines.left[index].text == AutoSellTrash.Language.Current_Equipment then
        index = index + 1
    end
    
    if not AutoSellTrash.QualityColorText then
        AutoSellTrash.QualityColorText = {}
        local hexColor = AutoSellTrash.QualityColors[1]:upper();
        AutoSellTrash.QualityColorText[hexColor] = 0;
        for i = 1, 5 do
            hexColor = AutoSellTrash.QualityColors[i+1]:upper();
            AutoSellTrash.QualityColorText[hexColor] = i;
        end
    end    
	    
    -- Item Name is the first thing in the tooltip
    local color = AutoSellTrashConfig_GetLineColor(lines, index);
	
    local quality = -1;
    if color then
        quality = AutoSellTrash.QualityColorText[color:upper()]
        if(quality == nil)then quality = -1; end;
    end	    
	    
    local d1, d2 = txt:match(AutoSellTrash.Language.Prefix_Durability.." (%d+)/(%d+)")
    d1 = tonumber(d1);
    d2 = tonumber(d2);
    if(not d1)then d1 = 0;end;
    if(not d2)then d2 = 0;end;
    
    local cost = 0;
    local c = txt:match(AutoSellTrash.Language.Prefix_Cost.." ([%,%.%d]+)")
    if(c ~= nil)then
    	c = string.gsub(c, "[%,%.]", "")
		c = tonumber(c)
    end;
	if(c)then cost = c;end;

	local l = tonumber(txt:match(AutoSellTrash.Language.Prefix_Level.." (%d+)"))
	if(l)then level = l;end;

    local tier = 0;
   	local t = tonumber(txt:match(AutoSellTrash.Language.Prefix_Tier.." (%d+)"))
   	if(t)then tier = t;end;
	    
    local stats = {}
    if(tier>0)then
    	for idx, line in pairs(lines.left) do
	        if line.color and
	            (line.color[1] == 1 or line.color[1] == 0) and  -- yellow, r=1,g=1
	            line.color[2] == 1 and line.color[3] == 0 then  -- green, g=1
				local line_color = Sol.color.ColorValuesToHexColor(line.color[1], line.color[2], line.color[3])
				local att = lines.right[idx];
				if(not att)then 
				else 
					att = att.text; 
	            	stats[att] = line.color[1]; -- yellow = 1, green = 0
					--DEFAULT_CHAT_FRAME:AddMessage("Idx: "..idx..", Att: "..line.text.."="..att.."="..line_color);
				end;
	        end
	    end
	end
    
    --DEFAULT_CHAT_FRAME:AddMessage("Durable: "..currentDur.."/"..totalDur);
    return d1,d2,tier,cost,quality,level,stats;
end

function AutoSellTrashConfig_Deromanize(str)
	local str1 = string.upper(str)
	local key = {}	
	key["M"]  = 1000
	key["D"]  = 500
	key["C"]  = 100
	key["L"]  = 50
	key["X"]  = 10
	key["V"]  = 5
	key["I"]  = 1  
    
    local arabic = 0
    local str_len = string.len(str1);
    local i = str_len;
  	while (i>0) do
  		local c1 = string.sub(str1, i, i);
  		local c2 = string.sub(str1, i+1, i+1);
  		local v1 = key[c1];
  		local v2 = key[c2];
  		if(v1 ~= nil)then
    		if (i<str_len)and( v1 < v2 )then
	      		arabic = arabic - v1;
	    	else
				arabic = arabic + v1;
			end
		end
		i = i - 1;
  	end
  	return arabic;    
end

function AutoSellTrashConfig_CheckMatches(name, exclude)
	local result = false;
	if(name ~= nil)and(exclude ~= nil)and(exclude ~= "")then
		for mask in string.gfind(exclude, "[^%,%;]*") do
			if(mask ~= nil)and(mask ~= "")then
    			local mask2 = string.gsub(mask, "(%*)", '.*')
				--DEFAULT_CHAT_FRAME:AddMessage("Mask: "..mask2)
    			if string.find(name, mask2) ~= nil then
	    			result = true;
					--DEFAULT_CHAT_FRAME:AddMessage("Name "..name.." matches "..mask)
	    			break;
	    		end
	    	end
	    end
	end
	return result;
end

function AutoSellTrashConfig_SellBagItem(bagIndex, place)
	local itemLink = GetBagItemLink(bagIndex)
	if(itemLink)then
		if AutoSellTrash_Settings[player].ChatMsg then
			DEFAULT_CHAT_FRAME:AddMessage(AutoSellTrash.Language.MsgSelling..itemLink);
		end
		UseBagItem(bagIndex);
	end
end

function AutoSellTrashConfig_SellItems()
	if not AutoSellTrash_Settings[player] then
		GameTooltip:SetOwner(AutoSellTrash_Config_SellButton, "ANCHOR_TOPLEFT", 4, 0);		
		GameTooltip:SetText( Sol.color.ColorText(AutoSellTrash.Language.MsgConfigIt, "ff4040"));
		GameTooltip:Show();
		return;
	end
	
	if not StoreFrame:IsVisible() then
		GameTooltip:SetOwner(AutoSellTrash_Config_SellButton, "ANCHOR_TOPLEFT", 4, 0);		
		GameTooltip:SetText( Sol.color.ColorText(AutoSellTrash.Language.MsgOpenStore, "ff4040"));
		GameTooltip:Show();
		return;
	end

   	local durability = tonumber(AutoSellTrash_Settings[player].MaxQuality);
   	if(not durability)then	durability = 101;end

   	local maxstatlevel = tonumber(AutoSellTrash_Settings[player].MaxStatLevel);
   	if(not maxstatlevel)then maxstatlevel = 7;end

   	local maxstatlevel2 = tonumber(AutoSellTrash_Settings[player].MaxStatLevel2);
   	if(not maxstatlevel2)then maxstatlevel2 = 4;end

   	local maxstatcnt = tonumber(AutoSellTrash_Settings[player].MaxStatCnt);
   	if(not maxstatcnt)then maxstatcnt = 1;end

   	local maxlevel = tonumber(AutoSellTrash_Settings[player].MaxLevel);
   	if(not maxlevel)then maxlevel = 53;end
	
	
	local rules = {}
	local rule_idx = 1;
	local rules_cnt = 0;
	
	local sign_table = AutoSellTrash.Language.Signatures;
	
	local signs = {};
	for n1, n2 in pairs(sign_table) do
		table.insert(signs, n1);
	end
	
	table.sort(signs, function(a, b) return string.len(a)>string.len(b); end);
	
	local rules_str = AutoSellTrash_Settings[player].Rules;
	if(rules_str ~= nil)and(rules_str ~= "")then
		for mask in string.gfind(rules_str, "[^%,%;]*") do
			if(mask ~= nil)and(mask ~= "")then
				for i = 1, table.getn(signs) do
					n1 = signs[i]
					n2 = sign_table[n1]
					if(n2 == "DURABILITY")then
						n2 = "D"
					elseif(n2 == "TIER")then
						n2 = "T"
					elseif(n2 == "LEVEL")then
						n2 = "L"
					elseif(n2 == "COST")then
						n2 = "C"
					elseif(n2 == "QUALITY")then
						n2 = "Q"
					end					
					mask = string.gsub(mask, n1, n2)
				end
    			rules[rule_idx] = mask;
    			rule_idx = rule_idx + 1;
    			rules_cnt = rules_cnt + 1;
				--DEFAULT_CHAT_FRAME:AddMessage("Adding rule: "..mask)
    		end
	    end
	end
	
	local total_sum = 0;
	local occupiedSlots, totalSlots = GetBagCount()	
	for bagSlot = 1,totalSlots do		
	
		local bagIndex, icon, name, itemCount, locked, invalid = GetBagItemInfo(bagSlot)
		local itemLink = GetBagItemLink(bagIndex)
		local d1,d2,tier,cost,quality,level,stats = AutoSellTrashConfig_GetBagItemAttr(bagSlot)		
		
        local is_matched = false;

		if (cost>0)and(itemLink ~= nil) then
        
	   		local exclude = AutoSellTrash_Settings[player].Exclude;
			is_matched = AutoSellTrashConfig_CheckMatches(name, exclude);
	
			if not is_matched then			
		   		local include = AutoSellTrash_Settings[player].Include;
			    is_matched = AutoSellTrashConfig_CheckMatches(name, include);
				if(is_matched)then
					--DEFAULT_CHAT_FRAME:AddMessage(itemLink .. " in include list")
					total_sum = total_sum + cost;
				    AutoSellTrashConfig_SellBagItem(bagIndex, 1);
				end
			
			else
				--DEFAULT_CHAT_FRAME:AddMessage(itemLink .. " in exclude list")
			end
				
	
			if (not is_matched)and(tier>0)and(level>0)and(d2>0) then
			
				for rule_idx = 1, rules_cnt do
			
					local mask = rules[rule_idx];
	    			local mask2 = string.gsub(mask, "([DCLQT])",
							function(a)
							    if a == "D" then
							        a = tostring(d2);
							    elseif a == "C" then
							        a = tostring(cost);
							    elseif a == "T" then
							        a = tostring(tier);
							    elseif a == "Q" then
							        a = tostring(quality);
							    elseif a == "L" then
							        a = tostring(level);
							    end
								return a;
							end
					)
					--DEFAULT_CHAT_FRAME:AddMessage(itemLink .. ": checking rule "..mask2)
	    			
				    local fn = loadstring("return (" .. mask2..")")
				    if fn ~= nil then
				    	local fn_result = {fn()}

		    			if (fn_result ~= nil)and(fn_result[1] == true) then
							--DEFAULT_CHAT_FRAME:AddMessage(itemLink.." matches "..mask2)
			    			is_matched = true;
			    			total_sum = total_sum + cost;
			    			AutoSellTrashConfig_SellBagItem(bagIndex, 2);
			    			break;
			    		end
				    end
	
		    	end
		    end
	    	
			if (not is_matched)and
			   (
			   ((quality == 0)and AutoSellTrash_Settings[player].Rarity.WHITE)or
			   ((quality == 1)and AutoSellTrash_Settings[player].Rarity.GREEN)or
			   ((quality == 2)and AutoSellTrash_Settings[player].Rarity.BLUE)or
			   ((quality == 3)and AutoSellTrash_Settings[player].Rarity.PURPLE)or
			   ((quality == 4)and AutoSellTrash_Settings[player].Rarity.EPIC)
			   )then
					if(d1>20)and(d1<=durability)then
						--DEFAULT_CHAT_FRAME:AddMessage("Slot: "..bagSlot..", D1: "..d1..", Q: "..quality..", C: "..cost..", L: "..level);
						if(level>0)and(level<=maxlevel)then
							local stat_cnt = 0;
							is_matched = false;
					    	for stat, is_yellow in pairs(stats) do
					    		_,_,stat_level_rom = string.find(stat, "([IVX]+)$")
					    		if(stat_level_rom)and(stat_level_rom ~= "")then
									stat_cnt = stat_cnt + 1
					    			local stat_level_dec = AutoSellTrashConfig_Deromanize(stat_level_rom);
					    			--DEFAULT_CHAT_FRAME:AddMessage("Stat : "..stat..", Lvl : "..stat_level_dec);
					    		 	if(stat_level_dec>0)then
					    		 		if  ((is_yellow == 0)and(stat_level_dec>maxstatlevel))or
					    		 			((is_yellow == 1)and(stat_level_dec>maxstatlevel2))then
											--DEFAULT_CHAT_FRAME:AddMessage("Stat matches: "..stat);
					    		 			is_matched = true;
					    		 			break;
					    		 		end
					    		 	end
					    		end;
						    end
						    if(not is_matched)and(stat_cnt>=maxstatcnt)then
						    	total_sum = total_sum + cost;
                                AutoSellTrashConfig_SellBagItem(bagIndex, 3);
						    end;
						end
					end
			end
		end
	end		
	
	if (total_sum>0)and AutoSellTrash_Settings[player].ChatMsg then
		DEFAULT_CHAT_FRAME:AddMessage(AutoSellTrash.Language.MsgTotalSum..": "..tostring(total_sum));
	end
			
end


-- Setup config screen, and make settings take effect
AutoSellTrash.VARIABLES_LOADED = function()

    Sol.config.CheckSettings("AutoSellTrash", AutoSellTrash.Defaults)   
    Sol.config.CreateSlashToHandleConfig(AutoSellTrash.Strings.AddonName, AutoSellTrash_Config, "ast")
    
    if AddonManager then
      local addon = {
          name = AutoSellTrash.Strings.AddonName, 
          description = AutoSellTrash.Strings.AddonDesc, 
          icon = AutoSellTrash.Strings.IconPath, 
          category = "Interface",
          configFrame = AutoSellTrash_Config, 
          slashCommands = "/ast", 
          onClickScript = AutoSellTrashConfig_Toogle,
          version = AutoSellTrash.Strings.Version,
          author = AutoSellTrash.Strings.Author,
      }
      if AddonManager.RegisterAddonTable then
          AddonManager.RegisterAddonTable(addon)
      else
          AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category, 
              addon.configFrame, addon.slashCommand, addon.miniButton, addon.onClickScript, addon.version, addon.author)
      end
    end
end

function AutoSellTrash_OnEvent(this, event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
    if event == "VARIABLES_LOADED" then
    
		AutoSellTrash_Config_Header:SetText		(AutoSellTrash.Language.GUI_Title);
		AutoSellTrash_Config_SaleTitle:SetText		(AutoSellTrash.Language.GUI_Sale);
		AutoSellTrash_Config_ExcludeTitle:SetText	(AutoSellTrash.Language.GUI_Exclude);
		AutoSellTrash_Config_IncludeTitle:SetText	(AutoSellTrash.Language.GUI_Include);
		AutoSellTrash_Config_RulesTitle:SetText	(AutoSellTrash.Language.GUI_Rules);

		AutoSellTrash_Config_MaxQualityTitle:SetText	(AutoSellTrash.Language.GUI_MaxQuality);
		AutoSellTrash_Config_MaxStatLevelTitle:SetText	(AutoSellTrash.Language.GUI_MaxStatLevel);
		AutoSellTrash_Config_MaxStatCntTitle:SetText	(AutoSellTrash.Language.GUI_MaxStatCnt);
		AutoSellTrash_Config_MaxLevelTitle:SetText	(AutoSellTrash.Language.GUI_MaxLevel);

		AutoSellTrash_Config_White_Text:SetText		(AutoSellTrash.ListEntries[1]);
		AutoSellTrash_Config_Green_Text:SetText		(AutoSellTrash.ListEntries[2]);
		AutoSellTrash_Config_Blue_Text:SetText		(AutoSellTrash.ListEntries[3]);
		AutoSellTrash_Config_Purple_Text:SetText	(AutoSellTrash.ListEntries[4]);
		AutoSellTrash_Config_Epic_Text:SetText		(AutoSellTrash.ListEntries[5]);

		AutoSellTrash_Config_ChatMsg_Text:SetText	(AutoSellTrash.Language.GUI_ChatMsg);

		AutoSellTrash_Config_SaveButton:SetText		(AutoSellTrash.Language.GUI_Save);
		AutoSellTrash_Config_CloseButton:SetText	(AutoSellTrash.Language.GUI_Close);
		    
		AutoSellTrash.LoadSavedSettings();
		AutoSellTrash.VARIABLES_LOADED();
        
		DEFAULT_CHAT_FRAME:AddMessage("AddOn loaded: |cff40ffc0"..AutoSellTrash.Addonname.." v"..AutoSellTrash.Version.."|r");
    elseif event == "LOADING_END" then
        AutoSellTrash.LoadSavedSettings();
    end
end

function AutoSellTrash_SaveCoord()
 AutoSellTrash_Settings[player].ConfigPosX , AutoSellTrash_Settings[player].ConfigPosY = AutoSellTrash_Config:GetPos();
end

function AutoSellTrash_OnUpdate(this, elapsed)

	local name = UnitName("player"); 
	if(not name)then
		name = "";
	elseif(name ~= player)then
		player = name;
       		AutoSellTrash.LoadSavedSettings();		
	end

	if (prevBagState == nil) or ( BagFrame:IsVisible() ~= prevBagState ) then
		prevBagState = BagFrame:IsVisible();
		if( prevBagState )then
			AutoSellTrash_Config_SellButton:ClearAllAnchors();
			AutoSellTrash_Config_SellButton:SetAnchor("TOPLEFT", "TOPRIGHT", "BagStoreUpButton", 4, 0)
			AutoSellTrash_Config_SellButton:Show();			
		else
			AutoSellTrash_Config_SellButton:Hide();
		end
	end
end


SLASH_AutoSellTrashToggle1 = "/ast";
SlashCmdList["AutoSellTrashToggle"] = AutoSellTrash.Toggle;
_G["AutoSellTrash"] = AutoSellTrash;
